<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Task 68 Pizza365 CRUD</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
</head>
<body class="hold-transition sidebar-mini">
<!-- Site wrapper -->
<div class="wrapper">
  <!-- Navbar -->
  <nav class="main-header navbar navbar-expand navbar-white navbar-light">
    <!-- Left navbar links -->
    <ul class="navbar-nav">
      <li class="nav-item">
        <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="index3.html" class="nav-link">Home</a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="#" class="nav-link">Contact</a>
      </li>
    </ul>
  </nav>
  <!-- /.navbar -->

  <!-- Main Sidebar Container -->
  <aside class="main-sidebar sidebar-dark-primary elevation-4">
    <!-- Brand Logo -->
    <a href="index3.html" class="brand-link">
      <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3" style="opacity: .8">
      <span class="brand-text font-weight-light">DevCamp 120</span>
    </a>

    <!-- Sidebar -->
    <div class="sidebar">
      <!-- Sidebar user (optional) -->
      <div class="user-panel mt-3 pb-3 mb-3 d-flex">
        <div class="image">
          <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
        </div>
        <div class="info">
          <a href="#" class="d-block">HuongNT</a>
        </div>
      </div>

      <!-- SidebarSearch Form -->
      <div class="form-inline">
        <div class="input-group" data-widget="sidebar-search">
          <input class="form-control form-control-sidebar" type="search" placeholder="Search" aria-label="Search">
          <div class="input-group-append">
            <button class="btn btn-sidebar">
              <i class="fas fa-search fa-fw"></i>
            </button>
          </div>
        </div>
      </div>

      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
          <li class="nav-item menu-open">
            <a href="#" class="nav-link">
              <i class="nav-icon fas fa-tachometer-alt"></i>
              <p>
                Dashboard
                <i class="right fas fa-angle-left"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="voucher.crud.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Voucher CRUD</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="menu.crud.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Menu CRUD</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="drink.crud.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Drink CRUD</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="country.crud.html" class="nav-link active">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Country CRUD</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="region.crud.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Region CRUD</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="user.crud.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>User CRUD</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="order.crud.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Order CRUD</p>
                </a>
              </li>
            </ul>
          </li>
          
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
    </div>
    <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1>Country - Region - CRUD</h1>
          </div>
          
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="container">
        <h2 style="text-align: center;">Quản trị danh sách các nước</h2>
        <div class="row">
        <!--<div class="col-sm-12">
          <button id="btn-clear-data" class="btn btn-danger">Delete All Data</button>
        </div>-->
        </div>
        <div class="jumbotron container">
          <div class="row form-group">
          <div class="col-sm-3">
            <label for="country-code">Mã Quốc gia</label>
          </div>
          <div class="col-sm-9">
            <input type="text" id="input-country-code" name="country-code" placeholder="country code"
            class="form-control">
          </div>
          </div>
          <div class="row form-group">
          <div class="col-sm-3">
            <label for="country-name">Tên Quốc Gia</label>
          </div>
          <div class="col-sm-9">
            <input type="text" id="input-country-name" name="country-name" placeholder="country name"
            class="form-control">
          </div>
          </div>
          
          <div class="row pull-right">
          <div class = "col-sm-3">
          </div>
          <div class="col-sm-3">
            <button id="btn-update-country" class="btn btn-info">Update country</button>
          </div>
          <div class="col-sm-3">
            <button id="btn-delete-country" class="btn btn-danger">Delete country</button>
          </div>
          <div class="col-sm-3">
            <button id="btn-create-country" class="btn btn-success">Add New country</button>
          </div>
          </div>
        </div>
        <table class="table table-bordered table-striped table-hover" id="user-table">
          <thead>
            <tr>
              <th>STT</th>
              <th>Mã quốc gia</th>
              <th>Tên quốc gia</th>
            </tr>
        </table>
      </div>
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->

  <footer class="main-footer">
    <div class="float-right d-none d-sm-block">
      <b>Version</b> 1.0.0
    </div>
    <strong>Copyright &copy; 2023 <a href="">DevCamp 120</a>.</strong> All rights reserved.
  </footer>

  <!-- Control Sidebar -->
  <aside class="control-sidebar control-sidebar-dark">
    <!-- Control sidebar content goes here -->
  </aside>
  <!-- /.control-sidebar -->
</div>
<!-- ./wrapper -->

<!-- jQuery -->
<script src="plugins/jquery/jquery.min.js"></script>
<!-- Bootstrap 4 -->
<script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
<!-- AdminLTE App -->
<script src="dist/js/adminlte.min.js"></script>
<script>
  "use strict";
/*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
// Biến toàn cục để lưu trữ id country đang đc update or delete. Mặc định = 0;
var gCountryId = 0;
const gBASE_URL = "http://localhost:8080/country";
const gCONTENT_TYPE = "application/json;charset=UTF-8";

$(document).ready(function(){
  loadDataToTable();
		
	/*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
	//Subtask 1- add click event to all rows
	$("#user-table").on("click", "tr", function(){
		onRowClick(this);
	})
	//task 2 - Update country: add event to save data button
	$("#btn-update-country").on("click",function(){
		onUpdateButtonClick();
	});
	//task 3 - Create new country
	$("#btn-create-country").on("click",function(){
		onCreateButtonClick();
	});
	//task 4 - Delete country selected
	$("#btn-delete-country").on("click",function(){
		onDeleteButtonClick();
	});
	//task 5 - Delete all countries
	//$("#btn-clear-data").on("click",function(){
	//	onDeleteAllBtnClick();
	//});
	/*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */ 
	//hàm xử lý sự kiện click row
	function onRowClick(paramRow){
		gCountryId = $(paramRow).find("td:eq(0)").html();
		console.log("Country id of selected row: " + gCountryId);
		//lấy thông tin country của row được click và hiển thị lên form
		var vCountry = callApiGetCountryById(gCountryId);
	};
	
	//hàm xử lý sự kiện nút save data
	function onUpdateButtonClick(){
		//khai báo country obj
		var vCountryObj = {
			countryCode: "",
			countryName: "",
		}
		// B1: Thu thập dữ liệu
		getUpdateCountryData(vCountryObj);
		// B2: Validate update
		var vIsCountryValid = validateCountryData(vCountryObj);
    	if (vIsCountryValid){
			// B3: update country
			$.ajax({
				url: gBASE_URL +"/update/"+ gCountryId,
				type: "PUT",
				contentType: gCONTENT_TYPE,
				data: JSON.stringify(vCountryObj),
				success: function(res){
					// B4: xử lý hiển thị
					handleUpdateCountrySuccess();
				},
				error: function(err){
					console.log(err.responseText);
				}
			})
		}
	}
	
	//hàm xử lý sự kiện nút thêm country
	function onCreateButtonClick(){
		//khai báo country obj
		var vCountryObj = {
			countryCode: "",
			countryName: "",
		}
		// B1: Thu thập dữ liệu
		getUpdateCountryData(vCountryObj);
		// B2: Validate data
		var vIsCountryValid = validateCountryData(vCountryObj);
    	if (vIsCountryValid){
			// B3: create country
			$.ajax({
				url: gBASE_URL + "/create",
				type: "POST",
				contentType: gCONTENT_TYPE,
				data: JSON.stringify(vCountryObj),
				success: function(res){
					// B4: xử lý hiển thị
					handleCreateCountrySuccess();
				},
				error: function(err){
					console.log(err.responseText);
				}
			})
		}
	}
	//hàm xử lý sự kiện nút xóa country được chọn và hiển thị trên form
	function onDeleteButtonClick(){
    //b1: thu thập dữ liệu
    //b2: validate
    //b3: thực hiện xóa - gọi API
      $.ajax({
        url: gBASE_URL +"/delete/"+ gCountryId,
        type: "DELETE",
        success: function(paramRes) {
          handleDeleteCountrySuccess();
        },
        error: function(paramErr) {
          alert("Xóa country không thành công");
        }
      });
	}
  
	/*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  function loadDataToTable(){
    var table = $("#user-table").DataTable({
      "columns": [
        {"data":"id"},
        {"data":"countryCode"},
        {"data":"countryName"},
      ]
    })
    $.ajax({
		url: gBASE_URL + "/all",
		type: "GET",
		dataType: "json",
		success: function(res){
			console.log(res);
			table.clear();
			table.rows.add(res);
			table.draw();
		},
		error: function(err){
			console.log(err.response);
		}
	})
  };

	//hàm gọi API lấy thông tin country của dòng được chọn
	function callApiGetCountryById(paramId){
		$.ajax({
			url: gBASE_URL +"/detail/"+ paramId,
			type: "GET",
			dataType: "json",
			success: function(res){
				console.log(res);
				displayCountryData(res);
			},
			error: function(err){
				console.log(err.responseText);
			}
		})
	}
	//hàm hiển thị thông tin country của dòng được click
	function displayCountryData(paramCountry){
		$("#input-country-code").val(paramCountry.countryCode);
		$("#input-country-name").val(paramCountry.countryName);
	}
	// hàm thu thập dữ liệu để update country
	function getUpdateCountryData(paramCountryObj) {
		paramCountryObj.countryCode =$("#input-country-code").val().trim();
		paramCountryObj.countryName =$("#input-country-name").val().trim();
	}

	// hàm validate data
	function validateCountryData(paramCountryObj) {
		if (paramCountryObj.countryCode === "") {
		alert("Cần nhập mã quốc gia");
		return false;
		}
		if (paramCountryObj.countryName === "") {
		alert("Cần nhập tên quốc gia");
		return false;
		}

		return true;
	}
	
	//hiển thị cập nhật country thành công
	function handleUpdateCountrySuccess(){
		alert("Sửa country có id: " + gCountryId + " thành công!");
    loadDataToTable();
	};
	//hiển thị thêm country thành công
	function handleCreateCountrySuccess(){
		alert("Thêm country thành công!");
    loadDataToTable();
	};
	//hiển thị cập nhật country thành công
	function handleDeleteCountrySuccess(){
		alert("Xóa country có id: " + gCountryId + " thành công!");
    loadDataToTable();
	};
})
</script>
</body>
</html>
